diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index 7ee772e51..c5228dce4 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -9,8 +9,10 @@ import java.util.List;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.SeasonManagerCycle;
@@ -35,7 +37,8 @@ public class Colorizers {
 	public static Colorizer cacao;
 	public static Colorizer thorn;
 	public static Colorizer palm;
-	
+
+	private static Dimension lastDimension;
 	private static Season lastSeason;
 	private static float lastSeasonProgress;
 	
@@ -51,10 +54,13 @@ public class Colorizers {
 		List<Season> seasons = Seasons.getAllSeasons();
 		
 		for(int i=0; i < allColorizers.size(); i++) {
-			allColorizers.get(i).setup(mc, seasons);
+			Colorizer colorizer = allColorizers.get(i);
+			colorizer.setup(mc, seasons);
+			TexturePack texturePack = colorizer.getTexturePack();
+			if(texturePack != null) {
+				System.out.println("Using " + colorizer.name + " color from texture pack " + texturePack.fileName);	
+			}
 		}
-		
-        update(true);
 	}
 	
 	public static void registerColorizers() {
@@ -78,15 +84,19 @@ public class Colorizers {
 	public static void update(boolean force) {
 		World world = mc.theWorld;
 		if(world == null) {
+			lastDimension = null;
 			return;
 		}
 		
 		Season currentSeason = world.seasonManager.getCurrentSeason();
+		Dimension currentDimension = world.dimension;
 		float seasonProgress = getSeasonProgress(world);
 		
 		boolean update;
 		if(force) {
 			update = true;
+		}else if(currentDimension != lastDimension) {
+			update = true;
 		}else if(currentSeason != lastSeason) {
 			update = true;
 		}else if(seasonProgress != lastSeasonProgress) {
@@ -99,6 +109,11 @@ public class Colorizers {
 			return;
 		}
 		
+		if(currentDimension != lastDimension) {
+			reload();
+		}
+		
+		lastDimension = currentDimension;
 		lastSeason = currentSeason;
 		lastSeasonProgress = seasonProgress;
 		
@@ -109,7 +124,12 @@ public class Colorizers {
 		
 		float fadeDurationInverse = 1.0f - fadeDuration;
 		
-		if(seasonProgress < 0.5f) {
+		if(seasonProgress == 0.5f) {
+			for(int i=0; i < allColorizers.size(); i++) {
+				allColorizers.get(i).update(currentDimension, currentSeason, currentSeason, 0.5f);
+			}
+			return;
+		}else if(seasonProgress < 0.5f) {
 			season1 = world.getSeasonManager().getPreviousSeason();
 			season2 = currentSeason;
 			blendFactor = seasonProgress + 0.5f; // 0.5 -> 1.0
@@ -136,7 +156,7 @@ public class Colorizers {
 		}
 		
 		for(int i=0; i < allColorizers.size(); i++) {
-			allColorizers.get(i).update(season1, season2, blendFactor);
+			allColorizers.get(i).update(currentDimension, season1, season2, blendFactor);
 		}
 	}
 	
@@ -145,26 +165,46 @@ public class Colorizers {
 		return colorizer;
 	}
 	
-	public static boolean loadColorData(ColorMap colorMap, String name) {
-		String path = "/assets/minecraft/textures/colormap/" + colorMap.colorizer.name + "/" + name + ".png";
+	public static TexturePack findTexturePackWithFile(Minecraft mc, String path) {
+		// TODO create list when texture pack is changed and reuse it
+		List<TexturePack> texturePacks = new ArrayList<>();
+		
+		texturePacks.add(mc.texturePackList.getDefaultTexturePack());
+		texturePacks.addAll(mc.texturePackList.selectedPacks);
+		
+		for(int i=texturePacks.size() - 1; i >= 0; i--) {
+			TexturePack texturePack = texturePacks.get(i);
+			if(texturePack.hasFile(path)) {
+				return texturePack;
+			}
+		}
+		
+		return null;
+	}
+	
+	public static ColorMap loadColorData(TexturePack texturePack, String path) {
+		if(texturePack == null) {
+			throw new NullPointerException();
+		}
 		
 		InputStream in = null;
 		BufferedImage image = null;
 		
 		try {
-			in = mc.texturePackList.getResourceAsStream(path);
+			in = texturePack.getResourceAsStream(path);
 			if(in == null) {
-				return false;
+				return null;
 			}
 			image = ImageIO.read(in);
 		}catch (Exception e) {
-			throw new RuntimeException("Loading colormap: '" + name + "'", e);
+			throw new RuntimeException("Loading colormap: '" + path + "'", e);
 		}finally {
 			try {
 				in.close();
 			}catch (Exception e) {}
 		}
-		
+
+		ColorMap colorMap = new ColorMap();
 		if(image.getWidth() == 1 && image.getHeight() == 1) {
 			int rgb = image.getRGB(0, 0);
 			
@@ -172,7 +212,7 @@ public class Colorizers {
 				colorMap.buffer[i] = rgb;
 			}
 			
-			return true;
+			return colorMap;
 		}
 		
 		if(image.getWidth() != 256 || image.getHeight() != 256) {
@@ -191,7 +231,7 @@ public class Colorizers {
 			}
 		}
 		
-		return true;
+		return colorMap;
 	}
 	
 	public static float getSeasonProgress(World world) {
diff --git a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
index 1f8d25d2f..30c469ce7 100644
--- a/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/BoatRenderer.java
@@ -64,7 +64,7 @@ public class BoatRenderer extends EntityRenderer<EntityBoat>
         float f4 = 0.75F;
         GL11.glScalef(f4, f4, f4);
         GL11.glScalef(1.0F / f4, 1.0F / f4, 1.0F / f4);
-        loadTexture("/item/boat.png");
+        loadTexture("/assets/minecraft/textures/entity/boat.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelBoat.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
         GL11.glPopMatrix();
diff --git a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
index dd6a4a5fd..44245ffee 100644
--- a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
@@ -110,7 +110,7 @@ public class MinecartRenderer extends EntityRenderer<EntityMinecart>
             GL11.glTranslatef(0.0F, -0.3125F, 0.0F);
             GL11.glScalef(1.0F / f5, 1.0F / f5, 1.0F / f5);
         }
-        loadTexture("/item/cart.png");
+        loadTexture("/assets/minecraft/textures/entity/cart.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelMinecart.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
         GL11.glPopMatrix();
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 2c35b8392..3bc301f0e 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -113,7 +113,6 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Item.sign, "minecraft"));
         addDispatch(new ItemModelStandard(Item.doorOak, "minecraft"));
         addDispatch(new ItemModelStandard(Item.doorGlass, "minecraft"));
-        addDispatch(new ItemModelStandard(Item.doorGlassTinted, "minecraft"));
         addDispatch(new ItemModelDoorPainted(Item.doorOakPainted));
         addDispatch(new ItemModelStandard(Item.bucket, "minecraft"));
         addDispatch(new ItemModelStandard(Item.bucketWater, "minecraft"));
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 03001dd00..a3114b2a5 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -141,6 +141,7 @@ public class TexturePackList
 		for (String string : packStrings){
 			for (TexturePack pack : availableTexturePacks){
 				if (string.equals(pack.fileName) && !selectedPacks.contains(pack)){
+					pack.readZipFile();
 					selectedPacks.add(pack);
 				}
 			}
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 46e6da8f6..8cb5e9ab4 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -61,7 +61,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
             GL11.glTranslatef(0.0F, -0.3125F, -0.4375F);
             signModel.signStick.showModel = false;
         }
-        loadTexture("/item/sign.png");
+        loadTexture("/assets/minecraft/textures/entity/sign.png");
         GL11.glPushMatrix();
         GL11.glScalef(scale, -scale, -scale);
         signModel.func_887_a();
diff --git a/src/main/java/net/minecraft/core/BuildChannel.java b/src/main/java/net/minecraft/core/BuildChannel.java
index 0fbabe872..066c404b9 100644
--- a/src/main/java/net/minecraft/core/BuildChannel.java
+++ b/src/main/java/net/minecraft/core/BuildChannel.java
@@ -10,7 +10,7 @@ public enum BuildChannel {
     }
 
     public String modifyVersionString(String version) {
-        if (this == STABLE) {
+        if (this == STABLE || this == PRERELEASE) {
             return version;
         } else {
             // Camel case channel name
diff --git a/src/main/java/net/minecraft/core/Global.java b/src/main/java/net/minecraft/core/Global.java
index ecbf06226..388d1dde2 100644
--- a/src/main/java/net/minecraft/core/Global.java
+++ b/src/main/java/net/minecraft/core/Global.java
@@ -22,5 +22,5 @@ public class Global
 	// 4th nibble: Prerelease version or patch version
 	// For example, 7.1_01 would be encoded as 0x7101
 	// 7.1 prerelease 1 would be encoded as 0x7111
-	public static final int MP_PROTOCOL_VERSION = 0x7100;
+	public static final int MP_PROTOCOL_VERSION = 0x7211;
 }
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 01adba7b1..96f29d0fc 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -1244,8 +1244,6 @@ public class Block
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block trapdoorPlanksOakPainted = new BlockTrapDoorPainted("trapdoor.planks.oak.painted", 573, Material.wood).withHardness(3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE);
-    public static final Block trapdoorGlassTinted = new BlockTrapDoorTinted("trapdoor.glass.tinted", 574, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block tnt = new BlockTNT("tnt", 580).withHardness(0.0F);
 
@@ -1265,10 +1263,6 @@ public class Block
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block doorGlassTop = new BlockDoorGlass("door.glass.top", 597, Material.glass, true).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block doorGlassTintedBottom = new BlockDoorGlassTinted("door.glass.tinted.bottom", 598, Material.glass, false).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
-            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block doorGlassTintedTop = new BlockDoorGlassTinted("door.glass.tinted.top", 599, Material.glass, true).withHardness(0.3F).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
-            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block mesh = new BlockMesh("mesh", 600).withHardness(1.5F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CAN_HANG_OFF);
diff --git a/src/main/java/net/minecraft/core/block/BlockDispenser.java b/src/main/java/net/minecraft/core/block/BlockDispenser.java
index b52c3e815..7eb395c69 100644
--- a/src/main/java/net/minecraft/core/block/BlockDispenser.java
+++ b/src/main/java/net/minecraft/core/block/BlockDispenser.java
@@ -5,6 +5,7 @@ import java.util.Random;
 import net.minecraft.core.entity.*;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.entity.projectile.*;
+import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
@@ -86,86 +87,66 @@ public class BlockDispenser extends BlockTileEntityRotatable
         }
     }
 
-    private void dispenseItem(World world, int i, int j, int k, Random random)
+    private void dispenseItem(World world, int x, int y, int z, Random random)
     {
-        int l = world.getBlockMetadata(i, j, k);
-        int i1 = 0;
-        int j1 = 0;
-        if(l == 3)
-        {
-            j1 = 1;
-        } else
-        if(l == 2)
-        {
-            j1 = -1;
-        } else
-        if(l == 5)
-        {
-            i1 = 1;
-        } else
-        {
-            i1 = -1;
+        int data = world.getBlockMetadata(x, y, z);
+        int xOffset = 0;
+        int zOffset = 0;
+        if (data == 3) {
+            zOffset = 1;
+        } else if (data == 2) {
+            zOffset = -1;
+        } else if (data == 5) {
+            xOffset = 1;
+        } else {
+            xOffset = -1;
         }
-        TileEntityDispenser tileentitydispenser = (TileEntityDispenser)world.getBlockTileEntity(i, j, k);
-        ItemStack itemstack = tileentitydispenser.getRandomStackFromInventory();
-        double d = (double)i + (double)i1 * 0.6D + 0.5D;
-        double d1 = (double)j + 0.5D;
-        double d2 = (double)k + (double)j1 * 0.6D + 0.5D;
-        if(itemstack == null)
+        TileEntityDispenser tileEntity = (TileEntityDispenser)world.getBlockTileEntity(x, y, z);
+        ItemStack itemStack = tileEntity.getRandomStackFromInventory();
+        double px = (double)x + (double)xOffset * 0.6D + 0.5D;
+        double py = (double)y + 0.5D;
+        double pz = (double)z + (double)zOffset * 0.6D + 0.5D;
+        if(itemStack == null)
         {
-            world.playSoundEffect(1001, i, j, k, 0);
-        } else
+            world.playSoundEffect(1001, x, y, z, 0);
+        }
+        else
         {
-            if(itemstack.itemID == Item.ammoArrow.id || itemstack.itemID == Item.ammoArrowGold.id)
-            {
-                EntityArrow entityarrow = itemstack.itemID == Item.ammoArrow.id ? new EntityArrow(world, d, d1, d2, 0) : new EntityArrowGolden(world, d, d1, d2);
-                entityarrow.setHeading(i1, 0.1D, j1, 1.1F, 6F);
-                entityarrow.setDoesArrowBelongToPlayer(true);
-                world.entityJoinedWorld(entityarrow);
-                world.playSoundEffect(1002, i, j, k, 0);
-            }
-            else if(itemstack.itemID == Item.ammoChargeExplosive.id)
-            {
-                EntityCannonball entitycannonball = new EntityCannonball(world, d, d1, d2);
-                entitycannonball.setHeading(i1, 0.1D, j1, 1.1F, 6F);
-                world.entityJoinedWorld(entitycannonball);
-                world.playSoundEffect(1002, i, j, k, 0);
-            }
-            else if(itemstack.itemID == Item.eggChicken.id)
+            if (itemStack.getItem() instanceof IDispensable)
             {
-                EntityEgg entityegg = new EntityEgg(world, d, d1, d2);
-                entityegg.setHeading(i1, 0.1D, j1, 1.1F, 6F);
-                world.entityJoinedWorld(entityegg);
-                world.playSoundEffect(1002, i, j, k, 0);
+                IDispensable dispensable = (IDispensable) itemStack.getItem();
+                dispensable.onDispensed(itemStack, world, px, py, pz, xOffset, zOffset, random);
+                world.playSoundEffect(1002, x, y, z, 0);
             }
-            else if(itemstack.itemID == Item.ammoSnowball.id)
+            else if (itemStack.itemID == Item.ammoArrow.id || itemStack.itemID == Item.ammoArrowGold.id)
             {
-                EntitySnowball entitysnowball = new EntitySnowball(world, d, d1, d2);
-                entitysnowball.setHeading(i1, 0.1D, j1, 1.1F, 6F);
-                world.entityJoinedWorld(entitysnowball);
-                world.playSoundEffect(1002, i, j, k, 0);
+                EntityArrow arrow = itemStack.itemID == Item.ammoArrow.id ? new EntityArrow(world, px, py, pz, 0) : new EntityArrowGolden(world, px, py, pz);
+                arrow.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+                arrow.setDoesArrowBelongToPlayer(true);
+                world.entityJoinedWorld(arrow);
+                world.playSoundEffect(1002, x, y, z, 0);
             }
-            else if(itemstack.itemID == Item.ammoPebble.id)
+            else if (itemStack.itemID == Item.ammoChargeExplosive.id)
             {
-                EntityPebble pebble = new EntityPebble(world, d, d1, d2);
-                pebble.setHeading(i1, 0.1D, j1, 1.1F, 6F);
-                world.entityJoinedWorld(pebble);
-                world.playSoundEffect(1002, i, j, k, 0);
+                EntityCannonball cannonball = new EntityCannonball(world, px, py, pz);
+                cannonball.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+                world.entityJoinedWorld(cannonball);
+                world.playSoundEffect(1002, x, y, z, 0);
             }
             else
             {
-                EntityItem entityitem = new EntityItem(world, d, d1 - 0.3D, d2, itemstack);
-                double d3 = random.nextDouble() * 0.1D + 0.2D;
-                entityitem.xd = (double)i1 * d3;
-                entityitem.yd = 0.2D;
-                entityitem.zd = (double)j1 * d3;
-                entityitem.xd += random.nextGaussian() * 0.0075D * 6D;
-                entityitem.yd += random.nextGaussian() * 0.0075D * 6D;
-                entityitem.zd += random.nextGaussian() * 0.0075D * 6D;
-                world.entityJoinedWorld(entityitem);
-                world.playSoundEffect(1000, i, j, k, 0);
+                EntityItem item = new EntityItem(world, px, py - 0.3D, pz, itemStack);
+                double randOffset = random.nextDouble() * 0.1D + 0.2D;
+                item.xd = (double)xOffset * randOffset;
+                item.yd = 0.2D;
+                item.zd = (double)zOffset * randOffset;
+                item.xd += random.nextGaussian() * 0.0075D * 6D;
+                item.yd += random.nextGaussian() * 0.0075D * 6D;
+                item.zd += random.nextGaussian() * 0.0075D * 6D;
+                world.entityJoinedWorld(item);
+                world.playSoundEffect(1000, x, y, z, 0);
             }
-            world.playSoundEffect(2000, i, j, k, i1 + 1 + (j1 + 1) * 3);
+            world.playSoundEffect(2000, x, y, z, xOffset + 1 + (zOffset + 1) * 3);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index d116f042b..bac18fe2a 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.IInventory;
 import com.mojang.nbt.CompoundTag;
@@ -73,8 +74,18 @@ public class TileEntityDispenser extends TileEntity
 
         if(i >= 0)
         {
+            ItemStack stack = getStackInSlot(i);
+            if (stack.getItem() instanceof IDispensable) {
+                IDispensable dispensable = (IDispensable) stack.getItem();
+                if (dispensable.isRemovedOnDispense()) {
+                    return decrStackSize(i, 1);
+                } else {
+                    return stack;
+                }
+            }
             return decrStackSize(i, 1);
-        } else
+        }
+        else
         {
             return null;
         }
diff --git a/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java b/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
index 955e10fc6..dd2b5a515 100644
--- a/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
+++ b/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
@@ -19,6 +19,7 @@ public class LookupFuelFurnace {
 		addFuelEntry(Block.planksOak.id, 300);
 		addFuelEntry(Block.planksOakPainted.id, 300);
 		addFuelEntry(Block.stairsPlanksOak.id, 300);
+		addFuelEntry(Block.stairsPlanksOakPainted.id, 300);
 		addFuelEntry(Block.slabPlanksOak.id, 150);
 		addFuelEntry(Block.slabPlanksOakPainted.id, 150);
 		addFuelEntry(Block.fencePlanksOak.id, 300);
diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index fbfd338d2..31187a773 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -32,7 +32,6 @@ import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
-import net.minecraft.core.item.IAmmoPickable;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolSword;
@@ -1348,20 +1347,23 @@ public abstract class EntityPlayer extends EntityLiving
         inventory.setInventorySlotContents(slot1, stack2);
     }
     public Item getNextArrow(){
-        ItemStack heldItem = getHeldItem();
-        if (heldItem.itemID != Item.toolBow.id) return null;
-
-        IAmmoPickable pickable = ((IAmmoPickable) Item.toolBow);
-        ItemStack ammoType = pickable.getPickedAmmoType(heldItem);
-
-        if (ammoType.itemID == Item.armorQuiver.id) {
-            return Item.ammoArrow;
+        Item nextArrow = null;
+        ItemStack quiverSlot = inventory.armorItemInSlot(2);
+        if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiver.id && quiverSlot.getMetadata() < quiverSlot.getMaxDamage()){
+            nextArrow = Item.ammoArrow;
         }
-        if (ammoType.itemID == Item.armorQuiverGold.id) {
-            return Item.ammoArrowPurple;
+        else if(quiverSlot != null && quiverSlot.itemID == Item.armorQuiverGold.id){
+            nextArrow = Item.ammoArrowPurple;
         }
-
-        return ammoType.getItem();
+        else if (hasItem(Item.ammoArrowGold))
+        {
+            nextArrow = Item.ammoArrowGold;
+        }
+        else if(hasItem(Item.ammoArrow))
+        {
+            nextArrow = Item.ammoArrow;
+        }
+        return nextArrow;
     }
     public int getArrowId(){
         return entityData.getInt(18);
diff --git a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
index f93236416..251f33b33 100644
--- a/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
+++ b/src/main/java/net/minecraft/core/entity/projectile/EntityFireball.java
@@ -21,12 +21,6 @@ public class EntityFireball extends EntityProjectile
         super(world);
         setSize(1.0F, 1.0F);
     }
-
-    public EntityFireball(World world, EntityLiving owner) {
-        super(world, owner);
-        setSize(1.0F, 1.0F);
-    }
-
     public EntityFireball(World world, double x, double y, double z,
             double vX, double vY, double vZ)
     {
diff --git a/src/main/java/net/minecraft/core/item/IDispensable.java b/src/main/java/net/minecraft/core/item/IDispensable.java
new file mode 100644
index 000000000..da3871c81
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/IDispensable.java
@@ -0,0 +1,13 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public interface IDispensable {
+    void onDispensed(ItemStack itemStack, World world, double x, double y, double z, int xOffset, int zOffset, Random random);
+
+    default boolean isRemovedOnDispense() {
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/Item.java b/src/main/java/net/minecraft/core/item/Item.java
index e29a0eaf4..13beb787b 100644
--- a/src/main/java/net/minecraft/core/item/Item.java
+++ b/src/main/java/net/minecraft/core/item/Item.java
@@ -260,7 +260,7 @@ public class Item
     public static Item toolPickaxeIron = (new ItemToolPickaxe("tool.pickaxe.iron", 16385, ToolMaterial.iron));
     public static Item toolAxeIron = (new ItemToolAxe("tool.axe.iron", 16386, ToolMaterial.iron));
     public static Item toolFirestriker = (new ItemFirestriker("tool.firestriker", 16387));
-    public static Item foodApple = (new ItemFood("food.apple", 16388, 4, 4, false, 16));
+    public static Item foodApple = (new ItemFood("food.apple", 16388, 4, 8, false, 8));
     public static Item toolBow = (new ItemBow("tool.bow", 16389));
     public static Item ammoArrow = (new Item("ammo.arrow", 16390));
     public static Item coal = (new ItemCoal("coal", 16391));
@@ -282,7 +282,7 @@ public class Item
     public static Item toolAxeDiamond = (new ItemToolAxe("tool.axe.diamond", 16407, ToolMaterial.diamond));
     public static Item stick = (new Item("stick", 16408));
     public static Item bowl = (new Item("bowl", 16409));
-    public static Item foodStewMushroom = (new ItemSoup("food.stew.mushroom", 16410, 10, 8));
+    public static Item foodStewMushroom = (new ItemSoup("food.stew.mushroom", 16410, 10, 16));
     public static Item toolSwordGold = (new ItemToolSword("tool.sword.gold", 16411, ToolMaterial.gold)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
     public static Item toolShovelGold = (new ItemToolShovel("tool.shovel.gold", 16412, ToolMaterial.gold));
     public static Item toolPickaxeGold = (new ItemToolPickaxe("tool.pickaxe.gold", 16413, ToolMaterial.gold));
@@ -297,7 +297,7 @@ public class Item
     public static Item toolHoeGold = (new ItemToolHoe("tool.hoe.gold", 16422, ToolMaterial.gold));
     public static Item seedsWheat = (new ItemSeeds("seeds.wheat", 16423, Block.cropsWheat));
     public static Item wheat = (new Item("wheat", 16424));
-    public static Item foodBread = (new ItemFood("food.bread", 16425, 5, 6, false, 16));
+    public static Item foodBread = (new ItemFood("food.bread", 16425, 5, 12, false, 8));
 
     public static Item armorHelmetLeather = (new ItemArmor("armor.helmet.leather", 16426, ArmorMaterial.LEATHER, 0));
     public static Item armorChestplateLeather = (new ItemArmor("armor.chestplate.leather", 16427, ArmorMaterial.LEATHER, 1));
@@ -324,10 +324,10 @@ public class Item
     public static Item armorLeggingsGold = (new ItemArmor("armor.leggings.gold", 16444, ArmorMaterial.GOLD, 2));
     public static Item armorBootsGold = (new ItemArmor("armor.boots.gold", 16445, ArmorMaterial.GOLD, 3));
     public static Item flint = (new Item("flint", 16446));
-    public static Item foodPorkchopRaw = (new ItemFood("food.porkchop.raw", 16447, 3, 8, true, 16));
-    public static Item foodPorkchopCooked = (new ItemFood("food.porkchop.cooked", 16448, 8, 8, true, 16));
+    public static Item foodPorkchopRaw = (new ItemFood("food.porkchop.raw", 16447, 3, 16, true, 4));
+    public static Item foodPorkchopCooked = (new ItemFood("food.porkchop.cooked", 16448, 8, 16, true, 4));
     public static Item painting = (new ItemPainting("painting", 16449));
-    public static Item foodAppleGold = (new ItemFood("food.apple.gold", 16450, 42, 0, false, 16));
+    public static Item foodAppleGold = (new ItemFood("food.apple.gold", 16450, 42, 0, false, 1));
     public static Item sign = (new ItemSign("sign", 16451));
     public static Item doorOak = (new ItemDoor("door.oak", 16452, Block.doorPlanksOakBottom, Block.doorPlanksOakTop));
     public static Item bucket = (new ItemBucketEmpty("bucket", 16453));
@@ -354,8 +354,8 @@ public class Item
     public static Item toolFishingrod = (new ItemFishingRod("tool.fishingrod", 16474));
     public static Item toolClock = (new Item("tool.clock", 16475));
     public static Item dustGlowstone = (new Item("dust.glowstone", 16476));
-    public static Item foodFishRaw = (new ItemFood("food.fish.raw", 16477, 2, 6, false, 16));
-    public static Item foodFishCooked = (new ItemFood("food.fish.cooked", 16478, 5, 6, false, 16));
+    public static Item foodFishRaw = (new ItemFood("food.fish.raw", 16477, 2, 12, false, 8));
+    public static Item foodFishCooked = (new ItemFood("food.fish.cooked", 16478, 5, 12, false, 8));
     public static Item dye = (new ItemDye("dye", 16479));
     public static Item bone = (new Item("bone", 16480));
     public static Item dustSugar = (new Item("dust.sugar", 16481));
@@ -406,7 +406,7 @@ public class Item
     public static Item quartz = (new Item("quartz", 16512));
     public static Item olivine = (new Item("olivine", 16513));
     public static Item ammoPebble = (new ItemPebble("ammo.pebble", 16514));
-    public static Item cherry = (new ItemFood("food.cherry", 16515, 2, 0, false, 16));
+    public static Item cherry = (new ItemFood("food.cherry", 16515, 2, 2, false, 8));
     public static Item bucketIcecream = (new ItemBucketIceCream("bucket.icecream", 16516, 10, 4)).setContainerItem(bucket);
     public static Item ammoArrowPurple = (new Item("ammo.arrow.purple", 16517)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
     public static Item label = (new ItemLabel("label", 16518));
@@ -428,7 +428,6 @@ public class Item
     public static Item rope = new ItemRope("rope", 16534, Block.rope);
     public static Item foodPumpkinPie = (new ItemPlaceable("food.pumpkin_pie", 16535, Block.pumpkinPie)).setMaxStackSize(1);
     public static Item wandMonsterSpawner = (new ItemWandSpawner("wand.monster", 16536)).setMaxStackSize(1);
-    public static Item doorGlassTinted = (new ItemDoor("door.glass.tinted", 16537, Block.doorGlassTintedBottom, Block.doorGlassTintedTop));
 
     public static int highestItemId = 0;
     public int id;
@@ -441,13 +440,6 @@ public class Item
     static 
     {
         StatList.onItemInit();
-
-        ((ItemBow) toolBow).addAmmoType(new ItemStack(ammoArrow));
-        ((ItemBow) toolBow).addAmmoType(new ItemStack(ammoArrowGold));
-        ((ItemBow) toolBow).addAmmoType(new ItemStack(armorQuiver));
-        ((ItemBow) toolBow).addAmmoType(new ItemStack(armorQuiverGold));
-
-        ((ItemHandCannonUnloaded) handcannonUnloaded).addAmmoType(new ItemStack(ammoChargeExplosive));
     }
 
     @Override
